#!/usr/bin/perl -w

my $dir='C:\Users\Marcell\Documents\VEMS_Files'; # 'MarcellTest9-99876';
if( $ARGV[0] ){
	$dir=$ARGV[0];
}
# my $tmp="$basedir/$key";

# ==============
# find newest file: updates $freshest->{name} and $freshest->{sec) if this file is modified more recently
# TODO: should we filter out vemsdetails.db ?
sub filecandidate
{
    my $file=shift;
    # print "FILECANDIDATE=$file\n" ;
    # ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size, $atime,$mtime,$ctime,$blksize,$blocks) = stat($filepath);
	$mtime_sec = (stat($file))[9]; # http://stackoverflow.com/questions/509576/how-do-i-get-a-files-last-modified-time-in-perl
	if( ! defined $freshest->{sec} || $mtime_sec > $freshest->{sec} ){
		$freshest->{sec} = $mtime_sec;
		$freshest->{name} = $file;
	 }
}
# ===============
sub slurp_file
{
	my $file = $freshest->{name};
    print "NEWEST=$file\n" ; 
    open FILE, '<' . $file || die $! ;
    binmode FILE ;
	while( $len = read(FILE, $data, 169108570)) {
		seek(FILE, 0, 1);	# clear EOF flag
		sleep(1);
		print "$len\n" ;
		# push @array, $data ;
	} # while
	close FILE ;
}

# =============
opendir (TEMP1, "$dir") ;
my @dirs = readdir (TEMP1) ;
closedir (TEMP1) ;

foreach my $dirs (@dirs) { # *
    next if ($dirs eq "." || $dirs eq "..") ;
    # print "---->$dirs\n" ;
    my $d = "$dir/$dirs" ;
    if (-d "$d") { # */
        opendir (TEMP2, $d) || die $! ;
        my @files = readdir (TEMP2) ;
        closedir (TEMP2) ;

        foreach my $file (@files) { # */*
		my $f = "$d/$file" ;
		next if ( -d "$f" ); # filter out directories $file eq "." || $file eq ".." ||
            	# normal file
		filecandidate( $f ); # find newest file (eg. written in last 5 mins)
        }
     }
}

slurp_file();
#==========================
